'#compiler freebasic
'#COMPILE GUI EXE 32  '64
'CONST UNICODE = 1   '0
#include once "windows.bi"
#include once "win\commctrl.bi"


#ifdef unicode   
  #ifndef zstr                                        'zero terminated unicode string (* bytes)
    #define zstr wstring
  #endif  
#ELSE
  #ifndef zstr                                        'zero terminated ansi string (* bytes)
    #define zstr zstring
  #endif  
#ENDIF


#INCLUDE ONCE "fb_movie.inc"


declare function fb_main as uinteger


END FB_MAIN


'***********************************************************************************************
'***********************************************************************************************


FUNCTION WindowProc (BYVAL hWnd AS HWND, BYVAL wMsg AS UINT, BYVAL wParam AS WPARAM, BYVAL lParam AS LPARAM) AS LRESULT
'***********************************************************************************************
' Main window procedure 
'***********************************************************************************************
DIM i           AS LONG
dim icc         as INITCOMMONCONTROLSEX
DIM ztext       AS ZSTR * MAX_PATH
dim r           AS tagrect
#ifdef unicode
dim szClassName AS wstring * 64
dim szCaption   AS wstring * 64
#ELSE
dim szClassName AS zstring * 64
dim szCaption   AS zstring * 64
#ENDIF
dim hwndc       AS hwnd
dim wstyle      AS DWORD
dim xstyle      AS DWORD

STATIC hinst    AS hmodule


  SELECT CASE wMsg
    CASE WM_CREATE                                   'creation of the main window
      hinst = getmodulehandle(BYVAL 0)
      icc.dwsize = sizeof(icc)                      
      icc.dwicc  = &HFFFF
      initcommoncontrolsex(@icc)

      movie_init

      szClassName = "JK_Movie"
      szCaption = "Movie 33"
      wstyle = WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN OR MCS_FIXED_SIZE or WS_Border
      xstyle = WS_EX_LEFT OR WS_EX_LTRREADING
      hwndc = CreateWindowEx(xstyle, szClassName, szCaption, wstyle, 30, 25, 300, 300, hwnd, cast(hmenu, 100), hinst, BYVAL 0) 


      r.left   = 450
      r.right  = r.left + 360 
      r.top    = 260
      r.bottom = r.top + 355 

      adjustwindowrectex @r, getwindowlongptr(hwnd, GWL_Style), 0, getwindowlongptr(hwnd, GWL_EXStyle)
      setwindowpos hwnd, 0, 450, 260, (r.right - r.left), (r.bottom - r.top), SWP_NoZorder


      ztext = "hello.avi"
      sendmessage hwndc, MCM_Setmovie, 0, cast(wparam, varptr(ztext))


      FUNCTION = 0                                    'success
      EXIT FUNCTION


    CASE WM_DESTROY                                  'exit - a good point for cleaning up
      PostQuitMessage 0                               'exit message loop in MAIN

      EXIT FUNCTION

  END SELECT


  FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)                    'default processing


END FUNCTION


'***********************************************************************************************


FUNCTION FB_MAIN AS uinteger
'***********************************************************************************************
' Main Program entry point
'***********************************************************************************************
dim uMsg        AS TAGMSG
dim hinst       AS hmodule
dim wce         AS WNDCLASSEX
dim szClassName AS ZSTR * 64
dim szCaption   AS ZSTR * 64
dim hMenu       AS hmenu
dim hwnd        AS hwnd
dim wstyle      AS DWORD
dim xstyle      AS DWORD


  hinst = GetModuleHandle(byval 0)

  szClassName = "NEWTEST"
  wce.cbSize = SIZEOF(wce)
  wce.STYLE = CS_HREDRAW OR CS_VREDRAW              'or CS_DBLCLKS
  wce.lpfnWndProc = procptr(WindowProc)
  wce.hInstance = hInst
  wce.hCursor = LoadCursor(NULL, BYVAL IDC_ARROW)
  wce.hbrBackground = GetStockObject(WHITE_BRUSH)
  wce.lpszClassName = @szClassName


  RegisterClassEx @wce


  szCaption = " New Layout"
  wstyle = WS_POPUP OR WS_BORDER OR WS_DLGFRAME OR WS_SYSMENU OR WS_MAXIMIZEBOX OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN OR WS_VISIBLE OR WS_CAPTION
  xstyle = WS_EX_WINDOWEDGE OR WS_EX_LEFT OR WS_EX_LTRREADING OR WS_EX_RIGHTSCROLLBAR
  hwnd = CreateWindowEx(xstyle, szClassName, szCaption, wstyle, 0 ,0, 0, 0, hwnd, 0, hinst, byval 0)


  ShowWindow hwnd, SW_SHOWDEFAULT                    'show main window
  UpdateWindow hwnd                                   'draw main window


  DO WHILE GetMessage(@uMsg, BYVAL NULL, 0, 0)       'message loop
    TranslateMessage @uMsg
    DispatchMessage @uMsg
  LOOP


  FUNCTION = uMsg.wParam


END FUNCTION


'***********************************************************************************************
'***********************************************************************************************
'***********************************************************************************************


